//
// ESTI - ARF
//
// First Version 2020 Patrick Harms
// Modified:
// - 2021, Sylvain Renault, Fraunhofer HHI
//
//
#define USING_OPENAPI_GENERATOR // alt. is Swagger

using System.IO;
using System.Collections.Generic;
using UnityEngine;

#if USING_OPENAPI_GENERATOR
using Org.OpenAPITools.Api;
using Org.OpenAPITools.Model;
#else
using IO.Swagger.Api;
using IO.Swagger.Model;
#endif

#if UNITY_EDITOR
public class RESTRequest
{
    static public void PostAddTrackable(string basePath)
    {
        Debug.Log("Posting Add Trackable to Server");
        TrackablesApi api = new TrackablesApi(basePath);
        Debug.Log("created Trackables API");

        EncodingInformationStructure trackableEncodingInformation =
            new EncodingInformationStructure(EncodingInformationStructure.DataFormatEnum.ARCORE, "1.0");

        List<double> trackableDimension = new List<double> { 5, 5, 5 };

        byte[] bytes = new byte[100];

        for (int i = 0; i < bytes.Length; i++)
        {
            bytes[i] = (byte)i;
        }

        Dictionary<string, List<string>> keyvalueTagList = new Dictionary<string, List<string>>();

        keyvalueTagList.Add("key", new List<string> { "value" });

        Trackable trackable = new Trackable(new System.Guid("67584958-3456-2342-4564-456723332345"),
                                            Trackable.TrackableTypeEnum.FIDUCIALMARKER,
                                            trackableEncodingInformation,
                                            bytes,
                                            new List<float>() { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 },
                                            Trackable.UnitSystemEnum.M,
                                            trackableDimension,
                                            keyvalueTagList);

        string result = api.AddTrackable(trackable);

        Debug.Log(result);
    }

    static public void PostAddWorldAnchor(string basePath)
    {
        Debug.Log("Posting Add World Anchor to Server");
        //WorldAnchorsApi api = new WorldAnchorsApi(basePath);
        Debug.Log("created World Anchors API");

        //string result = api.AddWorldAnchor("testCreatorUID", "METERS");

        //Debug.Log(result);
    }
}
#endif